<template>
  <div id="project-add-new">
    <div class="modal-header p-2">Thêm Dự án</div>
    <div class="modal-body">
      <ProjectForm v-model="projectLocal" :isValid="validateForm" />
    </div>
    <div class="modal-footer">
      <vs-button @click="onSave">Lưu</vs-button>
      <vs-button @click="$emit('close')">Hủy bỏ</vs-button>
    </div>
  </div>
</template>

<script>
import ProjectForm from "./ProjectForm.vue";
import ProjectService from "../../services/ProjectService";
import { ViewTypeEnums } from "../../constants/enums";

export default {
  name: "project-add-new",
  components: {
    ProjectForm
  },
  props: {
    info: { type: Object, default: () => ({}) }
  },
  data() {
    return {
      projectLocal: this.info
    };
  },
  computed: {
    validateForm() {
      return !this.errors.any() && this.projectLocal.name != "";
    }
  },
  methods: {
    clearFields() {
      Object.assign(this.projectLocal, {
        name: "",
        description: "",
        color: "berry-red",
        isFavorite: false,
        viewType: ViewTypeEnums.List
      });
    },
    async onSave() {
      this.$validator.validateAll().then(async result => {
        if (result) {
          try {
            const res = await ProjectService.update(
              this.projectLocal._id,
              this.projectLocal
            );

            this.$success(res.message);

            // Fetch Project
            this.$store.dispatch("todo/fetchProjects");

            // Clear field
            this.clearFields();

            this.$emit("close");
          } catch (error) {
            this.$error(error.message);
          }
        }
      });
    }
  }
};
</script>
